Remove the Unicode alternative for ".." (#3894)
[ghc-hetmet.git] / boot
diff --git a/boot b/boot
index 2c2d88b..70d99e6 100644 (file)
--- a/boot
+++ b/boot
@@ -1,68 +1,57 @@
-#! /bin/sh
-set -e
+#!/usr/bin/perl -w
 
-# Check that we have all boot packages.
-for dir in `grep "^[^# ][^ ]*  *[^ ][^ ]*  *[^ ][^ ]*$" packages | sed "s/ .*//"`
-do
-    if test ! -f $dir/LICENSE
-    then
-        echo "Error: $dir/LICENSE doesn't exist." >&2
-        echo "Maybe you haven't done './darcs-all get'?" >&2
-        exit 1
-    fi
-done
+use strict;
 
-# autoreconf everything that needs it.
-for dir in . libraries/*
-do
-    if test -f $dir/configure.ac
-    then
-        echo "Booting $dir"
-        ( cd $dir && autoreconf )
-    fi
-done
+use Cwd;
 
-# Alas, darcs doesn't handle file permissions, so fix a few of them.
-for f in boot darcs-all push-all validate
-do
-    if test -f $f
-    then
-        chmod +x $f
-    fi
-done
+# Create libraries/*/{ghc.mk,GNUmakefile}
+system("/usr/bin/perl", "-w", "boot-pkgs") == 0
+    or die "Running boot-pkgs failed: $?";
+
+my $dir;
+my $curdir;
 
-libraries=
+$curdir = &cwd();
 
-for f in libraries/*; do
-  pkgs=$f/ghc-packages
-  if test -f $pkgs; then
-    for p in `cat $pkgs`; do
-      libraries="$libraries $f/$p"
-    done
-  else
-    libraries="$libraries $f"
-  fi
-done
+# Check that we have all boot packages.
+open PACKAGES, "< packages";
+while (<PACKAGES>) {
+    if (/^#/) {
+        # Comment; do nothing
+    }
+    elsif (/^([a-zA-Z0-9\/.-]+) *[^ ]+ *[^ ]+$/) {
+        $dir = $1;
+        
+        # We would like to just check for an _darcs directory here, but in
+        # an lndir tree we avoid making _darcs directories, so it doesn't
+        # exist. We therefore require that every repo has a LICENSE file
+        # instead.
+        if (! -f "$dir/LICENSE") {
+            print STDERR "Error: $dir/LICENSE doesn't exist.\n";
+            die "Maybe you haven't done './darcs-all get'?";
+        }
+    }
+    elsif (/^([a-zA-Z0-9\/.-]+) *[^ ]+ *[^ ]+ *[^ ]+$/) {
+        # These are lines which refer to optional repositories, so their
+        # absence isn't an error.
+    }
+    else {
+        die "Bad line in packages file: $_";
+    }
+}
+close PACKAGES;
+
+# autoreconf everything that needs it.
+foreach $dir (".", glob("libraries/*/")) {
+    if (-f "$dir/configure.ac") {
+        print "Booting $dir\n";
+        chdir $dir;
+        system "autoreconf";
+        chdir $curdir;
+    }
+}
 
-for f in $libraries; do
-   dir=`basename $f`
-   cabals=`echo $f/*.cabal`
-   if test -f $cabals; then
-       echo "Creating $f/ghc.mk"
-       rm -f $f/ghc.mk
-       pkg=`basename ${cabals%.cabal}`
-       if test -f $f/ghc-stage; then
-           stage=`cat $f/ghc-stage`
-       else
-           stage=1
-       fi
-       top=`echo $f | sed "s/[^/]*/../g"`
-       echo "${f}_PACKAGE = ${pkg}" >> $f/ghc.mk
-       echo "\$(eval \$(call build-package,${f},dist-install,${stage}))" >> $f/ghc.mk
-       rm -f $f/GNUmakefile
-       echo "Creating $f/GNUmakefile"
-       echo "dir = ${f}" >> $f/GNUmakefile
-       echo "TOP = ${top}" >> $f/GNUmakefile
-       echo "include \$(TOP)/mk/sub-makefile.mk" >> $f/GNUmakefile
-   fi
-done
+# Alas, darcs doesn't handle file permissions, so fix a few of them.
+for my $file ("boot", "darcs-all", "push-all", "validate") {
+    chmod 0755, $file if -f $file;
+}